### *** This class provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.deployment

# Class ServiceConfigInstaller

java.lang.Object
com.sas.services.deployment.ServiceConfigInstaller

@SASScope("ALL") @BinaryCompatibilityOnly public final class ServiceConfigInstaller extends Object
Utility used to install an application's configuration into a SAS Foundation Service.

If the application's configuration conflicts with the service's existing configuration, then the install will be rejected. Alternatively, one may specify a merge policy that allows the existing service's configuration to be overwritten by the application's configuration.

Since:
  9.2

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `installConfig(String[] args)`
  Main method for an application which is used to install metadata describing an application's layered service configuration into a SAS Foundation Service.
  `static void`
  `main(String[] args)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### main

    public static void main(String[] args) throws ServiceException
    Throws:
      `ServiceException`

  - ### installConfig

    public static void installConfig(String[] args) throws ServiceException
    Main method for an application which is used to install metadata describing an application's layered service configuration into a SAS Foundation Service. Command line options used to run this application are summarized below.

    ## SAS Foundation Service

    When installing a layered configuration into a SAS Foundation Service, one must identify the service by specifying its name, its group name, and the name of its deployment. An application name must also be specified to indicate the name of the application that is to be associated with this layered configuration. The application name will also be used to uninstall an application's configuration from a SAS Foundation Service. The file that contains the service configuration that is to be installed must be specified. This file can be created by the Foundation Services Manager plug-in to the SAS Management Console by exporting a layered configuration to a file.

    SAS Foundation Service Command Line Options
    SAS Foundation Services
    Option | Description
    --- | ---
    `-serviceDeploymentName` | Name of the SAS Foundation Services deployment (SoftwareComponent.Name)
    `-serviceGroupName` | Name of the service deployment group (`Tree.Name`) that contains the SAS Foundation Service (ServiceComponent)
    `-serviceName` | Name of the SAS Foundation Service (ServiceComponent.Name) that is defined in the group in the deployment
    `-serviceApplication` | The name of the application whose layered service configuration is to be installed into the SAS Foundation Service
    `-serviceConfigFile` | File that contains a UTF-8 encoded SAS Foundation Service configuration which is to be installed into the SAS Foundation Service. The Foundation Services Manager plug-in to the SAS Management Console is used to export a configuration from a service to a file.

    ## Metadata Server

    One must specify the SAS Metadata Server and the desired connection approach.

    Parameters:
      `args` - Command line arguments specifying how to connect to the metadata server, whether a login credential or SSPI is used, the configuration directory for the services deployment and the name of the application whose service configurations are to be installed or uninstalled.
      - -metaserver <server>
      - -metaport <port>
      - -metarepository <repository>
      - -serviceDeploymentName <serviceDeploymentName>
      - -serviceGroupName <serviceGroupName>
      - -serviceName <serviceName>
      - -serviceApplication <serviceApplication>
      - -serviceConfigFile <serviceConfigFile>
      - Connection
        - using a Login Credential
          - -metauser <userID>
          - -metapass <password> or -password_on_stdin true (and specify -metapass via stdin)
        - using SSPI
          - -secpackagelist <secpackagelist>
          - -metaspn <spn> (optional)

      One may optionally specify whether an option prompt is presented by specifying the command line option `-isPrompting <true|false>`

    Throws:
      `ServiceException` - if unable to install the service's configuration.
    Since:
      9.2